const TemplateModule = "Template";
(() => {
    class Template {
        constructor() {
            moduleLoader.registerModule(TemplateModule);
            this.onInit();
        }

        onInit() {
            PrettyConsole.log(TemplateModule, "Initialize...")
            window.template = new VTepLCore({
                path: "/out/tpl/",
                cache: false // we want never caching :) i mean it's nice but horrible to update // maybe adding later checksum
            });
            PrettyConsole.debug(TemplateModule, "Use Cache? " + template.cache)
            // init requests
            this.loadArray(preLoader.getData('tpl'), true).catch(console.error);
        }

        async loadArray(files, moduleLoading = false) {
            window.template.loadArray(files).then(() => {
                if (moduleLoading) moduleLoader.finishModule(TemplateModule);
            }).catch(err => {
                PrettyConsole.error(TemplateModule, err);
                if (moduleLoading) moduleLoader.moduleErrored(TemplateModule, err);
            });
        }
    }

    moduleLoader.registerInit(() => {
        new Template();
    })
})();
